#pragma once
#include "Common.h"
#include "H1_.h"
#include "HA_.h"
#include "S3_.h"
#include "K3_.h"

using namespace std;
using namespace stdext;
#include "DlgBase.h"
#include <BizDataCenter.h>
//#include "ListCtrlEx.h"
#include "./grid/gridctrl.h"
#include "MultiCombo.h"
#include "BtnST.h"

//
class DlgBookmark : public DlgBase
{
	DECLARE_DYNCREATE(DlgBookmark)
protected:
	int m_sortcolumn = -1;
    HFONT m_hFontBold;
    HBRUSH m_brush;
	BOOL m_bAddMode;//߰ ,ܼ 簡ȸ
	SYSTEMTIME m_querytime;
	int m_nTimerMode = 0;
	int m_nModifiedCodeList = 0;
	CButtonST m_btnList[2];
	COLORREF m_fixedcolor, m_crtext;
	int m_rowheight = 16;
	int m_uplimitmap_count;
	LONG64 m_nLastRefreshTick;
public:
	DlgBookmark(CWnd* pParent = NULL);   // ǥ Դϴ.
	virtual ~DlgBookmark();
    void InitControls(int mode);
// ȭ  Դϴ.
	enum { IDD = IDD_BOOKMARK };
	//CListCtrlEx m_listctrl;
	CMultiCombo m_mcboxcode;
	GDCtrl m_Grid[2];
	GDCtrl* m_pGridFocus = NULL;
	static BOOL m_bTwiceGrid;
protected:
	byte m_bShowCode = 0;
	LONG64 m_nLastTick = 0;
	static byte m_nSelWhat;
	bool m_bShowDailySise = 0;
	int m_iquery = 0;
	int m_irecvquery = 0;
	int m_idailysise = 0;
	int m_bInTimer = 0;
	//ϸũ̿ܿ  ٸ ȸ 
	KEYLIST_STRING m_itemlist;
	void initgrid(GDCtrl* pGrid);
    void RefreshList();
	void RefreshBookmark();
	//ϻѰ
	void RefreshOther();
	int UnRealList();
	//irow = -1 ǵڿ
	int AddToList(GDCtrl* pGrid, HMSiseInfo* pSiseItem, HMStockInfo* pMI, int irow = -1);
	void SetListItem(GDCtrl* pGrid, HMSiseInfo *pSiseItem, HMStockInfo* pMI,int irow, bool fredraw = true);
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.
	DECLARE_MESSAGE_MAP()
    virtual BOOL OnInitDialog();
    int OnRecvTick(LPVOID lpData);
    int OnRecvHoga(LPVOID lpData);
public:
	static int CALLBACK OnGridAction(int row, int col, byte action, LPARAM urParam);
public:
    afx_msg void OnSize(UINT nType, int cx, int cy);
    afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
    afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	afx_msg void OnTimer(UINT_PTR nIDEvent);
	virtual void OnCancel();
    afx_msg void OnClickRefresh();
	afx_msg void OnCbnSelchangeWhat();
	afx_msg void OnCheckDailysise();
	afx_msg void OnCheckPolling();
	afx_msg void OnClickAddVF();
	afx_msg void OnClickAddVFAll();
	afx_msg void OnClickAddReal();
	afx_msg void OnClickAdd();
    afx_msg void OnClickRemove();
	afx_msg void OnClickLoadBookmark();
    afx_msg void OnClickSaveBookmark();
	afx_msg void OnClickQuerySise(); //üȸ
	afx_msg void OnMenuPopup(UINT nCmdID);
    ///////////////////////////////////////////////////////
    afx_msg LRESULT OnXMRecvData(WPARAM wParam, LPARAM lParam);
    virtual void OnOK();
	//afx_msg void OnNMClickListStock(NMHDR *pNMHDR, LRESULT *pResult);
	//afx_msg void OnNMRClickListStock(NMHDR *pNMHDR, LRESULT *pResult);
	//afx_msg void OnHdnItemClick(NMHDR *pNMHDR, LRESULT *pResult);
	//afx_msg void OnNMDblclkList(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnGvnClick(UINT idCtrl, NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnGvnRClick(UINT idCtrl, NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnGvnColumnSort(UINT idCtrl, NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnGvnQueryEdit(UINT idCtrl, NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnGvnEditEnd(UINT idCtrl, NMHDR* pNMHDR, LRESULT* pResult);

	afx_msg LRESULT OnSiseEvent(WPARAM wParam, LPARAM lParam);
	afx_msg void OnDestroy();
	afx_msg void OnClickBidhalt();
	afx_msg void OnClickExcept();
	afx_msg void OnBnClickedCmdAddreal();
	afx_msg void OnBnClickedCmdAddvolume();
};
